/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//I could make a class like the others but it's so god-damned basic why bother?
class registerPrompt{
    constructor(){
        //Grab input prompts
        this.name = document.querySelector("#register-channel-name");
        this.description = document.querySelector("#register-description");
        this.thumbnail = document.querySelector("#register-thumbnail");
        //Grab register button
        this.button = document.querySelector("#register-button");
        //Grab altcha widget
        this.altcha = document.querySelector("altcha-widget");
        //Setup null property to hold verification payload from altcha widget
        this.verification = null

        //Run input setup after DOM content has completely loaded to ensure altcha event listeners work
        document.addEventListener('DOMContentLoaded', this.setupInput.bind(this));
    }

    setupInput(){
        //Add verification event listener to altcha widget
        this.altcha.addEventListener("verified", this.verify.bind(this));

        //Add register event listener to register button
        this.button.addEventListener("click", this.register.bind(this));
    }

    verify(event){
        //pull verification payload from event
        this.verification = event.detail.payload;
    }

    register(){
        //If altcha verification isn't complete
        if(this.verification == null){
            //don't bother
            return;
        }

        //Send the registration informaiton off to the server
        utils.ajax.newChannel(this.name.value, this.description.value, this.thumbnail.value, this.verification);
    }
}

const registerForm = new registerPrompt();